<?php
// download file
$country = "switzerland";
$file = $country.".osm.bz2";

if (file_exists(("filetmp/".$file))) { // erase the file if exits
unlink ("filetmp/".$file);
}

if ($country == "germany") {
$url  = 'ftp5.gwdg.de/pub/misc/openstreetmap/download.geofabrik.de/'.$file;
} else {
$url  = 'http://download.geofabrik.de/openstreetmap/europe/'.$file;
};
    $path = 'filetmp/'.$file;
    $fdow = fopen($path, 'w');
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_FILE, $fdow);
    $data = curl_exec($ch);
    curl_close($ch);
    fclose($fdow);
    unset($fdow);
    
// Uncompress the file, without nd, member and node in a single line    

$countr_osm = "filetmp/".$country.".osm";
if (file_exists(($countr_osm))) { // erase the file if exits
unlink ($countr_osm);
}
$countr_2xml = $country."2.xml";
if (file_exists(($countr_2xml))) { // erase the file if exits
unlink ($countr_2xml);
}
$kount = 0;
$tempfile = "tmp_file.txt";

if (file_exists($countr_osm)) {
echo "El fichero OSM existe. No hace falta descomprimir el bz2 \n";
} else {
$fp = fopen ($countr_osm,"w"); // Open a file to save the extracted data

$bz = bzopen("filetmp/$file", "r") or die("Couldn't open $file"); // Open the compressed file
$decompressed_file = '';
while ($decompressed_file = bzread($bz, 4096)) { // read the compressed file by chunked
$ftmp = fopen ($tempfile,"w+");

if($decompressed_file === FALSE) die('Read problem');
if(bzerror($bz) === NULL) die('Compression Problem');

fwrite($ftmp,$decompressed_file, strlen($decompressed_file)); // save the chunk in a tmp file
fseek($ftmp, 0);

    while (!feof($ftmp)) {
    $line= fgets($ftmp, 1024);
         if ((strpos($line,"<nd ") !== false && strpos($line,"/>") !== false)
            || (strpos($line,"<member ") !== false && strpos($line,"/>") !== false) 
            || (strpos($line,"<node ") !== false && strpos($line,"/>") !== false))
         {
         // leave this line out of the output file
         } else {
         fwrite($fp,$line);
         $kount = ++$kount;
         echo $kount."\n";
         } // close if
    } // close while
    
    fclose($ftmp);
    unlink($tempfile);
} // close while

bzclose($bz);
fclose($fp);
// Delete the object to free memory
unset($bz);
unset($fp);
unset($ftmp);
$kount=0;

echo "el fichero OSM esta listo \n";
} // close if else


// extract only the data we need (define in array block) and save them in a new file
// the file is read node by node

$block = array('amenity', 'craft', 'emergency', 'historic', 'leisure', 'man_made', 'natural', 'office', 'shop', 'sport', 'tourism', 'aeroway', 'railway');

$xmlWriter = new XMLWriter();
$xmlWriter->openMemory();
$xmlWriter->setIndent(true);
$xmlWriter->startDocument('1.0','UTF-8');
$xmlWriter->startElement('osm');
$xmlWriter->startAttribute('version');
$xmlWriter->text('0.1');
$xmlWriter->startAttribute('generator');
$xmlWriter->text('Remiguel');


if(file_exists($countr_osm)) {
    $xml = new XMLReader(); 
    $xml->open($countr_osm); // input file as source

    $node=null;
    $kflag=false;

    while($xml->read()){ 
        if ($xml->nodeType==XMLReader::ELEMENT && $xml->name=='node') {
            $node=$xml->expand();
            $kflag=false;    //reset 
        }

        if ($kflag
            && $xml->nodeType==XMLReader::END_ELEMENT 
            && $xml->name=='node'
        ) {
            // read and write node attributes
            $xmlWriter->startElement('node'); 
            foreach ($node->attributes as $key => $value) {
            $xmlWriter->startAttribute($key);
            $xmlWriter->text($value->value);
            }
            // read and write tag attributes
            $tag = $node->getElementsByTagName("tag"); 
            foreach($tag as $d){
            $xmlWriter->startElement('tag');
            $xmlWriter->startAttribute('k');
            $xmlWriter->text($d->getAttribute('k'));
            $xmlWriter->startAttribute('v');
	        $xmlWriter->text($d->getAttribute('v'));
            $xmlWriter->endElement(); // close tag
            }
            $xmlWriter->endElement(); // close node
            // echo_memory_usage();
            echo $kount."\n";
            if ($kount > 2000) {
		    file_put_contents($countr_2xml, $xmlWriter->flush(true), FILE_APPEND);
		    $kount=0;
		    }
            $node=null;
            $kflag=false;
        }
        
        foreach ($block as $cat) {
        if (!$kflag
            && $xml->nodeType==XMLReader::ELEMENT 
            && $xml->name=='tag' 
            && $xml->getAttribute('k')==$cat
            && $xml->getAttribute('v') // it was k maybe a mistake
        ) {
            $kflag = true;
            $kount = ++$kount;
        }
                                  }

    } // close while
} // close if

$xmlWriter->endElement();
$xmlWriter->endDocument();
file_put_contents($countr_2xml, $xmlWriter->flush(true), FILE_APPEND);

unlink ($countr_osm);
unlink ("filetmp/".$file);

// Delete the object to free memory
unset($xmlWriter);
unset($xml);

if (file_exists(($country.".xml"))) {
    if (filesize($countr_2xml) > filesize($country.".xml")) {
    unlink ($country.".xml");
    rename($countr_2xml, $country.".xml");
    echo 'Actualizacion de '.$country. ' terminado';
    } else {
    unlink($countr_2xml);
    echo 'El fichero ' .$country. ' estaba ya al dia';
    }
} else {
rename($countr_2xml, $country.".xml");
echo 'Nuevo fichero: '.$country;
}


function echo_memory_usage() { 
        $mem_usage = memory_get_usage(true); 
        
        echo "<br/>\n"; 
        if ($mem_usage < 1024) 
            echo $mem_usage." bytes"; 
        elseif ($mem_usage < 1048576) 
            echo round($mem_usage/1024,2)." kilobytes"; 
        else 
            echo round($mem_usage/1048576,2)." megabytes"; 
            
        echo "<br/>\n"; 
    } 
?>